/**
 * pss.js
 */
import { HashTypes } from './typedef';
type PssParams = {
    k: number;
    hash: HashTypes;
    saltLength: number;
};
/**
 * Check PSS Length.
 * @param {String} mode - 'sign' or 'verify'
 * @param {Number} k - Octet length of modulus length, i.e., n.
 * @param {String} hash - Name of hash function.
 * @param {Number} saltLength - Length of salt.
 * @throws {Error} - Throws if Inconsistent, EncodingError, or InvalidMode.
 */
export declare const checkLength: (mode: 'sign' | 'verify', { k, hash, saltLength }: PssParams) => void;
export {};
